Codeforces Round #336 (Div. 2) D. Zuma

D - Zuma

题意:给你一个数字组成的串, 每次你能消去一段连续的回文串,问你最少需要操作几次把所有数字删完。

思路:区间dp, dp[ i ][ j ]表示删 i  到 j 段最少需要几次。

我们只考虑最左边的那个点的删除情况。

首先dp[ i ] [ j ] <= dp[ i + 1] [ j ] + 1

然后我们枚举 i 到 j  里面的点, 找到a[ k ] == a[ i ]

那么可以得到方程 dp[ i ] [ j ] = min (dp[ i ] [ j ] , dp[ i + 1] [ k - 1] + dp[ k + 1 ]  [ j ]), 因为对于a[ i ], a[ k ] 来说肯定能合到dp[ i + 1] [ k - 1]里面消去。

对于a[ i ] ==  a[ j ] 的情况, dp[ i ] [ j ] = min(dp[ i ] [ j ], dp[ i + 1] [ j - 1] )

 1 #include<bits/stdc++.h>
 2 #define LL long long
 3 #define fi first
 4 #define se second
 5 #define mk make_pair
 6 #define pii pair<int,int>
 7 #define ull unsigned long long
 8 using namespace std;
 9
10 const int N=500+7;
11 const int M=100+7;
12 const int inf=0x3f3f3f3f;
13 const LL INF=0x3f3f3f3f3f3f3f3f;
14 const int mod=1e9 + 9;
15
16 int n, a[N], f[N][N];
17
18 int dp(int i, int j) {
19     if(i > j) return 1;
20     if(i == j) return 1;
21     if(i + 1 == j) {
22         if(a[i] == a[j]) return 1;
23         else return 2;
24     }
25     if(f[i][j] != -1) return f[i][j];
26     f[i][j] = dp(i + 1, j) + 1;
27     if(a[i] == a[j]) {
28         f[i][j] = min(f[i][j], dp(i + 1, j - 1));
29     }
30     for(int k = i + 1; k < j; k++) {
31         if(a[k] == a[i]) {
32             f[i][j] = min(f[i][j], dp(i + 1, k - 1) + dp(k + 1, j));
33         }
34     }
35     return f[i][j];
36 }
37 int main() {
38     memset(f, -1, sizeof(f));
39     scanf("%d", &n);
40     for(int i = 1; i <= n; i++) {
41         scanf("%d", &a[i]);
42     }
43     int ans = dp(1, n);
44     printf("%d\n", ans);
45     return 0;
46 }
47 /*
48 6
49 1 1 1 1 1 1
50 */

原文地址:https://www.cnblogs.com/CJLHY/p/8887494.html

时间: 2024-08-28 23:42:19

Codeforces Round #336 (Div. 2) D. Zuma的相关文章

Codeforces Round #336 (Div. 2) D. Zuma(区间DP)

题目链接:https://codeforces.com/contest/608/problem/D 题意:给出n个宝石的颜色ci,现在有一个操作,就是子串的颜色是回文串的区间可以通过一次操作消去,问最少需要多少次操作可以消除所有的宝石.(每次操作消除一个回文串,最少操作次数清楚字符串) 题解:dp[l][r]表示区间(l,r)的最少操作次数,对于一个区间(l,r),有两种转移:①若存在c_l = c_i(l <= i <= r),可以由dp[l][i] + dp[i + 1][r]转移:②若c

Codeforces Round #336 (Div. 2) B. Hamming Distance Sum 计算答案贡献+前缀和

B. Hamming Distance Sum Genos needs your help. He was asked to solve the following programming problem by Saitama: The length of some string s is denoted |s|. The Hamming distance between two strings s and t of equal length is defined as , where si i

Codeforces Round #279 (Div. 2) ABCD

Codeforces Round #279 (Div. 2) 做得我都变绿了! Problems # Name     A Team Olympiad standard input/output 1 s, 256 MB  x2377 B Queue standard input/output 2 s, 256 MB  x1250 C Hacking Cypher standard input/output 1 s, 256 MB  x740 D Chocolate standard input/

Codeforces Round #428 (Div. 2)

Codeforces Round #428 (Div. 2) A    看懂题目意思就知道做了 #include<bits/stdc++.h> using namespace std; #pragma comment(linker, "/STACK:102400000,102400000") #define rep(i,a,b) for (int i=a; i<=b; ++i) #define per(i,b,a) for (int i=b; i>=a; --i

Codeforces Round #424 (Div. 2) D. Office Keys(dp)

题目链接:Codeforces Round #424 (Div. 2) D. Office Keys 题意: 在一条轴上有n个人,和m个钥匙,门在s位置. 现在每个人走单位距离需要单位时间. 每个钥匙只能被一个人拿. 求全部的人拿到钥匙并且走到门的最短时间. 题解: 显然没有交叉的情况,因为如果交叉的话可能不是最优解. 然后考虑dp[i][j]表示第i个人拿了第j把钥匙,然后 dp[i][j]=max(val(i,j),min(dp[i-1][i-1~j]))   val(i,j)表示第i个人拿

Codeforces Round #424 (Div. 2) C. Jury Marks(乱搞)

题目链接:Codeforces Round #424 (Div. 2) C. Jury Marks 题意: 给你一个有n个数序列,现在让你确定一个x,使得x通过挨着加这个序列的每一个数能出现所有给出的k个数. 问合法的x有多少个.题目保证这k个数完全不同. 题解: 显然,要将这n个数求一下前缀和,并且排一下序,这样,能出现的数就可以表示为x+a,x+b,x+c了. 这里 x+a,x+b,x+c是递增的.这里我把这个序列叫做A序列 然后对于给出的k个数,我们也排一下序,这里我把它叫做B序列,如果我

[Codeforces] Round #352 (Div. 2)

人生不止眼前的狗血,还有远方的狗带 A题B题一如既往的丝帛题 A题题意:询问按照12345678910111213...的顺序排列下去第n(n<=10^3)个数是多少 题解:打表,输出 1 #include<bits/stdc++.h> 2 using namespace std; 3 int dig[10],A[1005]; 4 int main(){ 5 int aa=0; 6 for(int i=1;;i++){ 7 int x=i,dd=0; 8 while(x)dig[++dd

Codeforces Round #273 (Div. 2)

Codeforces Round #273 (Div. 2) 题目链接 A:签到,仅仅要推断总和是不是5的倍数就可以,注意推断0的情况 B:最大值的情况是每一个集合先放1个,剩下都丢到一个集合去,最小值是尽量平均去分 C:假如3种球从小到大是a, b, c,那么假设(a + b) 2 <= c这个比較明显答案就是a + b了.由于c肯定要剩余了,假设(a + b)2 > c的话,就肯定能构造出最优的(a + b + c) / 3,由于肯定能够先拿a和b去消除c,而且控制a和b成2倍关系或者消除

Codeforces Round #339 (Div. 2) B. Gena&#39;s Code

B. Gena's Code It's the year 4527 and the tanks game that we all know and love still exists. There also exists Great Gena's code, written in 2016. The problem this code solves is: given the number of tanks that go into the battle from each country, f